---
title: Create a case link
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Case Management
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a case link{% #create-a-case-link %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                         |
| ----------------- | ---------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/cases/link |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/cases/link |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/cases/link      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/cases/link      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/cases/link  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/cases/link |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/cases/link     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/cases/link |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/cases/link |

### Overview

Creates a directional link between two cases (for example, case A blocks case B). The parent and child cases and their relationship type must be specified.

OAuth apps require the `cases_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#case-management) to access this endpoint.



### Request

#### Body Data (required)

Case link create request.

{% tab title="Model" %}

| Parent field | Field                                | Type   | Description                                                                                                                                                                                                                                                                                          |
| ------------ | ------------------------------------ | ------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]               | object | Data object for creating a case link.                                                                                                                                                                                                                                                                |
| data         | attributes [*required*]         | object | Attributes describing a directional relationship between two entities (cases, incidents, or pages).                                                                                                                                                                                                  |
| attributes   | child_entity_id [*required*]    | string | The UUID of the child (target) entity in the relationship.                                                                                                                                                                                                                                           |
| attributes   | child_entity_type [*required*]  | string | The type of the child entity. Allowed values: `CASE`, `INCIDENT`, `PAGE`, `AGENT_CONVERSATION`.                                                                                                                                                                                                      |
| attributes   | parent_entity_id [*required*]   | string | The UUID of the parent (source) entity in the relationship.                                                                                                                                                                                                                                          |
| attributes   | parent_entity_type [*required*] | string | The type of the parent entity. Allowed values: `CASE`, `INCIDENT`, `PAGE`, `AGENT_CONVERSATION`.                                                                                                                                                                                                     |
| attributes   | relationship [*required*]       | string | The type of directional relationship. Allowed values: `RELATES_TO` (bidirectional association), `CAUSES` (parent causes child), `BLOCKS` (parent blocks child), `DUPLICATES` (parent duplicates child), `PARENT_OF` (hierarchical), `SUCCESSOR_OF` (sequence), `ESCALATES_TO` (priority escalation). |
| data         | type [*required*]               | enum   | JSON:API resource type for case links. Allowed enum values: `link`                                                                                                                                                                                                                                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "child_entity_id": "4417921d-0866-4a38-822c-6f2a0f65f77d",
      "child_entity_type": "CASE",
      "parent_entity_id": "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
      "parent_entity_type": "CASE",
      "relationship": "BLOCKS"
    },
    "type": "link"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing a single case link.

| Parent field | Field                                | Type   | Description                                                                                                                                                                                                                                                                                          |
| ------------ | ------------------------------------ | ------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]               | object | A directional link representing a relationship between two entities. At least one entity must be a case.                                                                                                                                                                                             |
| data         | attributes [*required*]         | object | Attributes describing a directional relationship between two entities (cases, incidents, or pages).                                                                                                                                                                                                  |
| attributes   | child_entity_id [*required*]    | string | The UUID of the child (target) entity in the relationship.                                                                                                                                                                                                                                           |
| attributes   | child_entity_type [*required*]  | string | The type of the child entity. Allowed values: `CASE`, `INCIDENT`, `PAGE`, `AGENT_CONVERSATION`.                                                                                                                                                                                                      |
| attributes   | parent_entity_id [*required*]   | string | The UUID of the parent (source) entity in the relationship.                                                                                                                                                                                                                                          |
| attributes   | parent_entity_type [*required*] | string | The type of the parent entity. Allowed values: `CASE`, `INCIDENT`, `PAGE`, `AGENT_CONVERSATION`.                                                                                                                                                                                                     |
| attributes   | relationship [*required*]       | string | The type of directional relationship. Allowed values: `RELATES_TO` (bidirectional association), `CAUSES` (parent causes child), `BLOCKS` (parent blocks child), `DUPLICATES` (parent duplicates child), `PARENT_OF` (hierarchical), `SUCCESSOR_OF` (sequence), `ESCALATES_TO` (priority escalation). |
| data         | id [*required*]                 | string | The case link identifier.                                                                                                                                                                                                                                                                            |
| data         | type [*required*]               | enum   | JSON:API resource type for case links. Allowed enum values: `link`                                                                                                                                                                                                                                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "child_entity_id": "4417921d-0866-4a38-822c-6f2a0f65f77d",
      "child_entity_type": "CASE",
      "parent_entity_id": "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
      "parent_entity_type": "CASE",
      "relationship": "BLOCKS"
    },
    "id": "804cd682-55f6-4541-ab00-b608b282ea7d",
    "type": "link"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/cases/link" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "child_entity_id": "4417921d-0866-4a38-822c-6f2a0f65f77d",
      "child_entity_type": "CASE",
      "parent_entity_id": "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
      "parent_entity_type": "CASE",
      "relationship": "BLOCKS"
    },
    "type": "link"
  }
}
EOF 
                
##### 

```python
"""
Create a case link returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.case_management_api import CaseManagementApi
from datadog_api_client.v2.model.case_link_attributes import CaseLinkAttributes
from datadog_api_client.v2.model.case_link_create import CaseLinkCreate
from datadog_api_client.v2.model.case_link_create_request import CaseLinkCreateRequest
from datadog_api_client.v2.model.case_link_resource_type import CaseLinkResourceType

body = CaseLinkCreateRequest(
    data=CaseLinkCreate(
        attributes=CaseLinkAttributes(
            child_entity_id="4417921d-0866-4a38-822c-6f2a0f65f77d",
            child_entity_type="CASE",
            parent_entity_id="bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
            parent_entity_type="CASE",
            relationship="BLOCKS",
        ),
        type=CaseLinkResourceType.LINK,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_case_link"] = True
with ApiClient(configuration) as api_client:
    api_instance = CaseManagementApi(api_client)
    response = api_instance.create_case_link(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create a case link returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_case_link".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CaseManagementAPI.new

body = DatadogAPIClient::V2::CaseLinkCreateRequest.new({
  data: DatadogAPIClient::V2::CaseLinkCreate.new({
    attributes: DatadogAPIClient::V2::CaseLinkAttributes.new({
      child_entity_id: "4417921d-0866-4a38-822c-6f2a0f65f77d",
      child_entity_type: "CASE",
      parent_entity_id: "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
      parent_entity_type: "CASE",
      relationship: "BLOCKS",
    }),
    type: DatadogAPIClient::V2::CaseLinkResourceType::LINK,
  }),
})
p api_instance.create_case_link(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create a case link returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.CaseLinkCreateRequest{
		Data: datadogV2.CaseLinkCreate{
			Attributes: datadogV2.CaseLinkAttributes{
				ChildEntityId:    "4417921d-0866-4a38-822c-6f2a0f65f77d",
				ChildEntityType:  "CASE",
				ParentEntityId:   "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
				ParentEntityType: "CASE",
				Relationship:     "BLOCKS",
			},
			Type: datadogV2.CASELINKRESOURCETYPE_LINK,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateCaseLink", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCaseManagementApi(apiClient)
	resp, r, err := api.CreateCaseLink(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CaseManagementApi.CreateCaseLink`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CaseManagementApi.CreateCaseLink`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create a case link returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CaseManagementApi;
import com.datadog.api.client.v2.model.CaseLinkAttributes;
import com.datadog.api.client.v2.model.CaseLinkCreate;
import com.datadog.api.client.v2.model.CaseLinkCreateRequest;
import com.datadog.api.client.v2.model.CaseLinkResourceType;
import com.datadog.api.client.v2.model.CaseLinkResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createCaseLink", true);
    CaseManagementApi apiInstance = new CaseManagementApi(defaultClient);

    CaseLinkCreateRequest body =
        new CaseLinkCreateRequest()
            .data(
                new CaseLinkCreate()
                    .attributes(
                        new CaseLinkAttributes()
                            .childEntityId("4417921d-0866-4a38-822c-6f2a0f65f77d")
                            .childEntityType("CASE")
                            .parentEntityId("bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f")
                            .parentEntityType("CASE")
                            .relationship("BLOCKS"))
                    .type(CaseLinkResourceType.LINK));

    try {
      CaseLinkResponse result = apiInstance.createCaseLink(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CaseManagementApi#createCaseLink");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create a case link returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_case_management::CaseManagementAPI;
use datadog_api_client::datadogV2::model::CaseLinkAttributes;
use datadog_api_client::datadogV2::model::CaseLinkCreate;
use datadog_api_client::datadogV2::model::CaseLinkCreateRequest;
use datadog_api_client::datadogV2::model::CaseLinkResourceType;

#[tokio::main]
async fn main() {
    let body = CaseLinkCreateRequest::new(CaseLinkCreate::new(
        CaseLinkAttributes::new(
            "4417921d-0866-4a38-822c-6f2a0f65f77d".to_string(),
            "CASE".to_string(),
            "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f".to_string(),
            "CASE".to_string(),
            "BLOCKS".to_string(),
        ),
        CaseLinkResourceType::LINK,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateCaseLink", true);
    let api = CaseManagementAPI::with_config(configuration);
    let resp = api.create_case_link(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create a case link returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createCaseLink"] = true;
const apiInstance = new v2.CaseManagementApi(configuration);

const params: v2.CaseManagementApiCreateCaseLinkRequest = {
  body: {
    data: {
      attributes: {
        childEntityId: "4417921d-0866-4a38-822c-6f2a0f65f77d",
        childEntityType: "CASE",
        parentEntityId: "bf0cbac6-4c16-4cfb-b6bf-ca5e0ec37a4f",
        parentEntityType: "CASE",
        relationship: "BLOCKS",
      },
      type: "link",
    },
  },
};

apiInstance
  .createCaseLink(params)
  .then((data: v2.CaseLinkResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
